
# ПолеФормы / FormField

    
    
Предназначен для отображения и редактирования реквизитов формы.


  
  
## Свойства
    
### Значение / Value
Доступ: Чтение/Запись

Тип значения: Строка, Дата, Число

    
    
Значение элемента формы.


  
  
### Вид / Type
Доступ: Чтение/Запись

Тип значения: ВидПоляФормы

    
    
Определяет способ представления данных реквизита в форме.


  
  
### Имя / Name
Доступ: Чтение/Запись
    
    
Имя элемента


  
  
### Видимость / Visible
Доступ: Чтение/Запись
    
    
Управление видимостью


  
  
### Доступность / Enabled
Доступ: Чтение/Запись
    
    
Управление доступностью


  
  
### Заголовок / Title
Доступ: Чтение/Запись
    
    
Заголовок к полю. Пустая строка означает автоматическое определение. Для отключения вывода заголовка следует установить свойство ПоложениеЗаголовка в значение Нет.


  
  
### ПоложениеЗаголовка / TitleLocation
Доступ: Чтение/Запись

Тип значения: ПоложениеЗаголовкаЭлементаФормы

    
    
Определяет положение заголовка относительно поля в макете формы.
Следует заметить, что для отключения вывода заголовка следует установить это свойство в значение Нет.
Свойство Заголовок, содержащее пустую строку, означает автоматическое определение заголовка, а не ее отключение.


  
  
### СписокВыбора / ChoiceList
Доступ: Чтение/Запись

Тип значения: Соответствие

    
    
Установка / получение списка выбора для ПолеСоСписком, ПолеСписка


  
  
### Родитель / Parent
Доступ: Чтение

Тип значения: ГруппаФормы, Форма

    
    
Содержит ссылку на родительский элемент.

  
  
### ТолькоПросмотр / ReadOnly
Доступ: Чтение/Запись
    
    
Содержит признак возможности/невозможности редактирования отображаемых данных.


  
  
### Высота / Height
Доступ: Чтение/Запись
    
    
Высота


  
  
### Ширина / Width
Доступ: Чтение/Запись
    
    
Ширина


  
  
### АвтоматическийРазмер / AutoSize
Доступ: Чтение/Запись
    
    
Автоматический размер


  
  
### Закрепление / Dock
Доступ: Чтение/Запись

Тип значения: СтильЗакрепления

    
    
Вариант закрепления.

  
  
### КодНажатойКлавиши / KeyCodeDown
Доступ: Чтение
    
    
Код нажатой клавиши


  
  
### НажатАльт / AltDown
Доступ: Чтение
    
    
Нажат альт


  
  
### НажатКонтрол / CtrlDown
Доступ: Чтение
    
    
Нажат контрол


  
  
### НажатШифт / ShiftDown
Доступ: Чтение
    
    
Нажат шифт


  
  
## Методы
    
### УстановитьДействие / SetAction()
    
    
    
Установить обработчик события
Возможные события:
- ПриИзменении - Обработка события изменения значения
- ПриВыборе - При нажатии Enter
- ПриДвойномКлике - Обработка двойного клика (Событие только для ListBox)
- ПриНажатииНаКнопку - При нажатии клавиши (KeyDown)


  
  
#### Пример:
    ПолеФормы1.УстановитьДействие(ЭтотОбъект, "ПриИзменении", "ПриИзмененииПолеФормы1");
    

#### Параметры

* *contex*: Ссылка на скрипт в котором находится обработчик события

* *eventName*: Имя обрабатываемого события.

* *methodName*: Имя метода обработчика события

### ПолучитьДействие / GetAction()
    
    
    
Получает имя установленного обработчика события.


  
  
#### Пример:
    Форма.УстановитьДействие(ЭтотОбъект, "ПриОткрытии", "ПриОткрытииФормы");
    Форма.ПолучитьДействие("ПриОткрытии");
    // вернет: "ПриОткрытииФормы"
    

#### Параметры

* *eventName*: Имя события

#### Возвращаемое значение

Имя метода обработчика события

  