
# Форма / Form

    
    
Основной контейнер для отображения.
Используется для доступа к свойствам, методам и событиям управляемой формы в целом, а также к коллекции ее элементов управления.


  
  
## Свойства
    
### ВидПоляФормы / FormFieldType
Доступ: Чтение

Тип значения: ВидПоляФормы

    
    
Системное перечисление


  
  
### ВидГруппыФормы / FormGroupType
Доступ: Чтение

Тип значения: ВидГруппыФормы

    
    
Системное перечисление


  
  
### ПоложениеЗаголовка / TitleLocation
Доступ: Чтение

Тип значения: ПоложениеЗаголовкаЭлементаФормы

    
    
Системное перечисление


  
  
### Заголовок / Caption
Доступ: Чтение/Запись
    
    
Заголовок формы


  
  
### Родитель / Parent
Доступ: Чтение
    
    
Родитель формы. Всегда Неопределено


  
  
### Имя / Name
Доступ: Чтение/Запись
    
    
Имя формы


  
  
### Элементы / Items
Доступ: Чтение

Тип значения: Элементы

    
    
Содержит коллекцию подчиненных элементов группы.


  
  
### АвтоматическийРазмер / AutoSize
Доступ: Чтение/Запись
    
    
Автоматический размер


  
  
### Высота / Height
Доступ: Чтение/Запись
    
    
Высота


  
  
### Ширина / Width
Доступ: Чтение/Запись
    
    
Ширина


  
  
### Лево / Left
Доступ: Чтение/Запись
    
    
Положение слева от края экрана


  
  
### Право / Right
Доступ: Чтение
    
    
Положение справа от края экрана


  
  
### Верх / Top
Доступ: Чтение/Запись
    
    
Положение сверху от края экрана


  
  
### Низ / Bottom
Доступ: Чтение
    
    
Положение снизу от края экрана


  
  
### Закрепление / Dock
Доступ: Чтение/Запись
    
    
Неиспользуется. Создан для реализации интерфейса


  
  
### ТекущийЭлемент / CurrentItem
Доступ: Запись

Тип значения: ПолеФормы, ГруппаФормы, КнопкаФормы

    
    
Устанавливает текущий активный элемент формы.


  
  
### СтартоваяПозиция / StartPosition
Доступ: Чтение/Запись

Тип значения: ПозицияОкнаПриОткрытии

    
    
Стартовая позиция окна при открытии

ПозицияОкнаПриОткрытии:
- ЦентрЭкрана
- Ручное


  
  
#### Пример:
    Форма.СтартоваяПозиция = ПозицияОкнаПриОткрытии.Ручное;
    

### Иконка / Icon
Доступ: Чтение/Запись
    
    
Файл с иконкой для окна. Допускается только *.ico


  
  
### СостояниеОкна / WindowState
Доступ: Чтение/Запись
    
    
Состояние окна при открытии

СостояниеОкна:
- Развернутое
- Свернутое
- Обычное


  
  
#### Пример:
    Форма.СостояниеОкна = СостояниеОкна.Обычное
    

## Методы
    
### Показать / Show()
    
    
    
Показать форму (показывает модально)


  
  
### ПоказатьНеМодально / ShowNotModal()
    
    
    
Используется для прохождения тестов. Если открывать не модально сразу закроется и будут доступны другие методы


  
  
### Закрыть / Close()
    
    
    
Закрыть форму


  
  
### УстановитьДействие / SetAction()
    
    
    
Установить обработчик события.
Возможные события:
- ПриОткрытии - При первом открытии формы
- ПриЗакрытии - При закрытии формы


  
  
#### Пример:
    Форма.УстановитьДействие(ЭтотОбъект, "ПриОткрытии", "ПриОткрытииФормы");
    

#### Параметры

* *contex*: Ссылка на скрипт в котором находится обработчик события

* *eventName*: Имя обрабатываемого события

* *methodName*: Имя метода обработчика события

### ПолучитьДействие / GetAction()
    
    
    
Получает имя установленного обработчика события.


  
  
#### Пример:
    Форма.УстановитьДействие(ЭтотОбъект, "ПриОткрытии", "ПриОткрытииФормы");
    Форма.ПолучитьДействие("ПриОткрытии");
    // вернет: "ПриОткрытииФормы"
    

#### Параметры

* *eventName*: Имя события

#### Возвращаемое значение

Имя метода обработчика события

  
## Конструкторы

  
### По умолчанию