
# ТаблицаФормы / FormTable

    
    
Элемент управляемой формы, предназначенный для отображения реквизитов формы табличных типов.


  
  
## Свойства
    
### Имя / Name
Доступ: Чтение/Запись
    
    
Имя элемента


  
  
### Видимость / Visible
Доступ: Чтение/Запись
    
    
Управление видимостью


  
  
### Доступность / Enabled
Доступ: Чтение/Запись
    
    
Управление доступностью


  
  
### Заголовок / Title
Доступ: Чтение/Запись
    
    
Заголовок к полю. Пустая строка означает автоматическое определение. Для отключения вывода заголовка следует установить свойство ПоложениеЗаголовка в значение Нет.


  
  
### ПоложениеЗаголовка / TitleLocation
Доступ: Чтение/Запись

Тип значения: ПоложениеЗаголовкаЭлементаФормы

    
    
Определяет положение заголовка относительно поля в макете формы.
Следует заметить, что для отключения вывода заголовка следует установить это свойство в значение Нет.
Свойство Заголовок, содержащее пустую строку, означает автоматическое определение заголовка, а не ее отключение.


  
  
### Родитель / Parent
Доступ: Чтение

Тип значения: ГруппаФормы, Форма

    
    
Содержит ссылку на родительский элемент.

  
  
### Высота / Height
Доступ: Чтение/Запись
    
    
Высота


  
  
### Ширина / Width
Доступ: Чтение/Запись
    
    
Ширина


  
  
### АвтоматическийРазмер / AutoSize
Доступ: Чтение/Запись
    
    
Автоматический размер


  
  
### Закрепление / Dock
Доступ: Чтение/Запись

Тип значения: СтильЗакрепления

    
    
Вариант закрепления.

  
  
### ПутьКДанным / DataPath
Доступ: Чтение/Запись
    
    
Провайдер с данными.


  
  
### ВыделенныеСтроки / SelectedRows
Доступ: Чтение

Тип значения: ArrayImpl

    
    
Содержит массив номеров выделенных строк.


  
  
### ТекущаяСтрока / CurrentRow
Доступ: Чтение/Запись
    
    
Номер текущей строки таблицы.


  
  
### ТекущиеДанные / CurrentData
Доступ: Чтение
    
    
Представляет доступ к текущим данным (данным текущей строки).


  
  
### Колонки / Columns
Доступ: Чтение

Тип значения: Массив

    
    
Колонки таблицы.


  
  
### ТекущийЭлемент / CurrentItem
Доступ: Чтение
    
    
Текущее поле в таблице.


  
  
## Методы
    
### УстановитьДействие / SetAction()
    
    
    
Установить обработчик события
Возможные события:
- ПриПотереФокусаЯчейки - Обработка события изменения значения
- ПриВыборе - При нажатии Enter
- ПриДвойномКлике - Обработка двойного клика


  
  
#### Пример:
    Поле1.УстановитьДействие(ЭтотОбъект, "ПриПотереФокусаЯчейки", "ПриПотереФокусаЯчейки");
    Поле1.УстановитьДействие(ЭтотОбъект, "ПриДвойномКлике", "ПриДвойномКлике");
    Поле1.УстановитьДействие(ЭтотОбъект, "ПриВыборе", "ПриВыборе");
    

#### Параметры

* *contex*: Ссылка на скрипт в котором находится обработчик события

* *eventName*: Имя обрабатываемого события.

* *methodName*: Имя метода обработчика события

### ПолучитьДействие / GetAction()
    
    
    
Получает имя установленного обработчика события.


  
  
#### Пример:
    Форма.УстановитьДействие(ЭтотОбъект, "ПриВыборе", "ПриВыбореЯчейки");
    Форма.ПолучитьДействие("ПриВыборе");
    // вернет: "ПриВыбореЯчейки"
    

#### Параметры

* *eventName*: Имя события

#### Возвращаемое значение

Имя метода обработчика события

  
### Обновить / Refresh()
    
    
    
Обновляет данные в таблице.


  
  