#Использовать asserts
#Использовать gui

Перем ВидыПоляФормы;
Перем ПоложенияЗаголовка;
Перем ТекстПриИзменении;

Функция ПолучитьСписокТестов(Тестирование) Экспорт

	СписокТестов = Новый Массив;
	СписокТестов.Добавить("Тест_Должен_СоздатьПоле");
	СписокТестов.Добавить("Тест_Должен_ПровестиРаботуСоЗначением");
	СписокТестов.Добавить("Тест_Должен_УстановитьЗаголовок");
	СписокТестов.Добавить("Тест_Должен_УстановитьИмя");
	СписокТестов.Добавить("Тест_Должен_УстановитьВидимость");
	СписокТестов.Добавить("Тест_Должен_УстановитьДоступность");
	СписокТестов.Добавить("Тест_Должен_ВернутьРодителя");
	СписокТестов.Добавить("Тест_Должен_УстановитьТолькоПросмотр");
	СписокТестов.Добавить("Тест_Должен_ПроверитьПоложениеЗаголовка");
	
	Возврат СписокТестов;

КонецФункции

Функция ПолучитьФорму()
	
	УправляемыйИнтерфейс = Новый УправляемыйИнтерфейс();
	Форма = УправляемыйИнтерфейс.СоздатьФорму();

	ВидыПоляФормы = Форма.ВидПоляФормы;
	ПоложенияЗаголовка = Форма.ПоложениеЗаголовка;

	Возврат Форма;

КонецФункции

Процедура Тест_Должен_СоздатьПоле() Экспорт

	Форма = ПолучитьФорму();
	Форма.ПоказатьНеМодально();	

	Поле1 = Форма.Элементы.Добавить("Поле1", "ПолеФормы", Неопределено);
	Поле1.Вид = ВидыПоляФормы.ПолеИндикатора;

	Ожидаем.Что(Форма.Элементы.Найти("Поле1")).Существует();

КонецПроцедуры

Процедура Тест_Должен_ПровестиРаботуСоЗначением() Экспорт

	Форма = ПолучитьФорму();

	Поле1 = Форма.Элементы.Добавить("Поле1", "ПолеФормы", Неопределено);
	Поле1.Вид = ВидыПоляФормы.ПолеИндикатора;
	Поле1.Значение = 1;

	Форма.ПоказатьНеМодально();

	Ожидаем.Что(Форма.Элементы.Найти("Поле1").Значение).Равно(1);

КонецПроцедуры

Процедура Тест_Должен_УстановитьЗаголовок() Экспорт

	НовыйЗаголовок = "Новый заголовок";

	Форма = ПолучитьФорму();
	Поле1 = Форма.Элементы.Добавить("Поле1", "ПолеФормы", Неопределено);
	Поле1.Вид = ВидыПоляФормы.ПолеИндикатора;
	Поле1.Заголовок = НовыйЗаголовок;
	Форма.ПоказатьНеМодально();

	Ожидаем.Что(Форма.Элементы.Найти("Поле1").Заголовок).Равно(НовыйЗаголовок);

КонецПроцедуры

Процедура Тест_Должен_УстановитьИмя() Экспорт

	НовоеИмя = "НовоеИмя";

	Форма = ПолучитьФорму();
	Поле1 = Форма.Элементы.Добавить("Поле1", "ПолеФормы", Неопределено);
	Поле1.Вид = ВидыПоляФормы.ПолеИндикатора;
	Поле1.Имя = НовоеИмя;
	Форма.ПоказатьНеМодально();

	Ожидаем.Что(Форма.Элементы.Найти(НовоеИмя).Имя).Равно(НовоеИмя);

КонецПроцедуры

Процедура Тест_Должен_УстановитьВидимость() Экспорт

	Форма = ПолучитьФорму();
	Форма.ПоказатьНеМодально();

	Поле1 = Форма.Элементы.Добавить("Поле1", "ПолеФормы", Неопределено);
	Поле1.Вид = ВидыПоляФормы.ПолеИндикатора;
	Поле1.Видимость = Истина;

	Ожидаем.Что(Поле1.Visible).ЭтоИстина();

	Поле1.Видимость = Ложь;
	Ожидаем.Что(Поле1.Visible).ЭтоЛожь();
	
КонецПроцедуры

Процедура Тест_Должен_УстановитьДоступность() Экспорт

	Форма = ПолучитьФорму();
	Форма.ПоказатьНеМодально();

	Поле1 = Форма.Элементы.Добавить("Поле1", "ПолеФормы", Неопределено);
	Поле1.Вид = ВидыПоляФормы.ПолеИндикатора;
	
	Поле1.Доступность = Истина;
	Ожидаем.Что(Поле1.Enabled).ЭтоИстина();

	Поле1.Доступность = Ложь;
	Ожидаем.Что(Поле1.Enabled).ЭтоЛожь();
	
КонецПроцедуры

Процедура Тест_Должен_ВернутьРодителя() Экспорт

	Форма = ПолучитьФорму();
	Форма.ПоказатьНеМодально();

	Поле1 = Форма.Элементы.Добавить("Поле1", "ПолеФормы", Неопределено);
	Поле1.Вид = ВидыПоляФормы.ПолеИндикатора;

	Ожидаем.Что(Строка(Форма.Элементы.Найти("Поле1").Родитель)).Равно("УправляемаяФорма");

	Группа = Форма.Элементы.Добавить("Группа", "ГруппаФормы", Неопределено);

	Поле2 = Форма.Элементы.Добавить("Поле2", "ПолеФормы", Группа);
	Поле2.Вид = ВидыПоляФормы.ПолеИндикатора;

	Ожидаем.Что(Группа.Элементы.Найти("Поле2").Родитель).Равно(Форма.Элементы.Найти("Группа"));
	
КонецПроцедуры

Процедура Тест_Должен_УстановитьТолькоПросмотр() Экспорт

	Форма = ПолучитьФорму();
	Форма.ПоказатьНеМодально();

	Поле1 = Форма.Элементы.Добавить("Поле1", "ПолеФормы", Неопределено);
	Поле1.Вид = ВидыПоляФормы.ПолеИндикатора;
	
	Поле1.ТолькоПросмотр = Истина;
	Ожидаем.Что(Форма.Элементы.Найти("Поле1").ReadOnly).ЭтоИстина();

	Поле1.ТолькоПросмотр = Ложь;
	Ожидаем.Что(Форма.Элементы.Найти("Поле1").ReadOnly).ЭтоЛожь();
	
КонецПроцедуры

Процедура Тест_Должен_ПроверитьПоложениеЗаголовка() Экспорт

	Форма = ПолучитьФорму();
	Форма.ПоказатьНеМодально();

	Поле1 = Форма.Элементы.Добавить("Поле1", "ПолеФормы", Неопределено);
	Поле1.Вид = ВидыПоляФормы.ПолеИндикатора;
	Поле1.ПоложениеЗаголовка = ПоложенияЗаголовка.Авто;
	Ожидаем.Что(Форма.Элементы.Найти("Поле1").ПоложениеЗаголовка).Равно(ПоложенияЗаголовка.Авто);

	Поле1.ПоложениеЗаголовка = ПоложенияЗаголовка.Верх;
	Ожидаем.Что(Форма.Элементы.Найти("Поле1").ПоложениеЗаголовка).Равно(ПоложенияЗаголовка.Верх);

	Поле1.ПоложениеЗаголовка = ПоложенияЗаголовка.Лево;
	Ожидаем.Что(Форма.Элементы.Найти("Поле1").ПоложениеЗаголовка).Равно(ПоложенияЗаголовка.Лево);

	Поле1.ПоложениеЗаголовка = ПоложенияЗаголовка.Нет;
	Ожидаем.Что(Форма.Элементы.Найти("Поле1").ПоложениеЗаголовка).Равно(ПоложенияЗаголовка.Нет);

	Поле1.ПоложениеЗаголовка = ПоложенияЗаголовка.Низ;
	Ожидаем.Что(Форма.Элементы.Найти("Поле1").ПоложениеЗаголовка).Равно(ПоложенияЗаголовка.Низ);

	Поле1.ПоложениеЗаголовка = ПоложенияЗаголовка.Право;
	Ожидаем.Что(Форма.Элементы.Найти("Поле1").ПоложениеЗаголовка).Равно(ПоложенияЗаголовка.Право);

КонецПроцедуры
